"""
Copyright (c) 2014-2017, Bitnine Inc.
Copyright (c) 2022, Vinzenz Feenstra

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

from psycopg import adapters

from psycopg3_agensgraph._edge import Edge, EdgeDumper, EdgeLoader
from psycopg3_agensgraph._graphid import GraphId, GraphIdDumper, GraphIdLoader
from psycopg3_agensgraph._graphpath import Path, PathDumper, PathLoader
from psycopg3_agensgraph._oids import (
    _EDGE_OID,
    _GRAPHID_OID,
    _GRAPHPATH_OID,
    _VERTEX_OID,
)
from psycopg3_agensgraph._property import Property, PropertyDumper
from psycopg3_agensgraph._vertex import Vertex, VertexDumper, VertexLoader

adapters.register_dumper(Vertex, VertexDumper)
adapters.register_dumper(GraphId, GraphIdDumper)
adapters.register_dumper(Path, PathDumper)
adapters.register_dumper(Edge, EdgeDumper)
adapters.register_dumper(Property, PropertyDumper)
adapters.register_loader(_GRAPHID_OID, GraphIdLoader)
adapters.register_loader(_VERTEX_OID, VertexLoader)
adapters.register_loader(_GRAPHPATH_OID, PathLoader)
adapters.register_loader(_EDGE_OID, EdgeLoader)
